#include<avr\io.h>
#include<inttypes.h>
#include<avr\interrupt.h>
#include<avr\eeprom.h>
#include <avr/wdt.h>

uint8_t licznik, stary_stan, time, sS1, ktora_liczba=0, time2, stan=0, ktory_wysw, liczba;
uint16_t time_opoznienie, czas_zgaszenia;
uint16_t czas_do_przerwy = 5000;

uint8_t tablica[10] =
{0b01111011, 0b00001001, 0b10110011, 0b10011011, 0b11001001, 0b11011010, 0b11111010, 0b00001011, 0b11111011, 0b11011011};

uint8_t lewo[] = {0b1011, 0b1101, 0b0100, 0b0010};
uint8_t prawo[] = {0b0111, 0b1110, 0b1000, 0b0001};

uint8_t co_wpisano[6];

void wyswietl(uint8_t, uint8_t);
void ktora_strona(void);
void zwieksz_stan(void);
void zmniejsz_stan(void);
void opoznienie_dluzsze(void);
void delay1us(uint16_t n);
void kod_ok(void);
uint8_t S1(void);
void kod_ok(void);
void kod_zly(void);
void sprawdz_poprawnosc(void);

void wyswietl(uint8_t co, uint8_t kropki) //funkcja wywietlania liczb na wywietlaczu, musi ona by cigle wywoywana! 
{
	uint8_t jednostki, dziesiatki; //liczb dwucyfrow musimy rozbi na dwie cyfry - jednostki i dziesitki
	
	jednostki = co % 10; //cyfra jednostek to poprostu reszta z dzielenia z dziesiciu liczby waciwej
	dziesiatki = co / 10; //cyfr dziesitek otrzymamy dzielc liczb waciw przez dziesi - cz uamkowa zostanie zignorowana
	
	PORTB = 0; // Zgaszenie wszystkich wyswietlaczy
	PORTD &= (~(1<<0)) & (~(1<<1)); // Zgaszenie wszystkich wyswietlaczy
	ktory_wysw++; 
	if(ktory_wysw > 1) ktory_wysw = 0; //reszta kodu to wybr wywietlacza - raz wywietlamy jednostki, a przy nastpnym wywoaniu funkcji dziesitki
	switch(ktory_wysw)
	{
		case 0: PORTB = tablica[jednostki];
				if(co == 100) PORTB = 0;
				if(kropki & 1<<0) PORTB |= 1<<2; 
				PORTD |= 0b10; 
		break;
		case 1: if(dziesiatki > 0) PORTB = tablica[dziesiatki]; // Jeeli cyfra dziesitek jest rwna zero to nie zawiecamy wogle wywietlacza dziesitek 
					if(co == 100) PORTB = 0;
				if(kropki & 1<<1) PORTB |= 1<<2;  
				PORTD |= 0b01;
		break;
	}

}

// Funkcja, ktra rozpoznaje w ktr stron przekrcono enkoder i odpowiednio wywouje funkcj zwieksz_stan() lub zmniejsz_stan()

	void ktora_strona() 
	{
	uint8_t nowy_stan = (PIND >> 2) & 0b11;
	
	for(uint8_t x=0; x<=3; x++)
		{
		if((nowy_stan | stary_stan) == lewo[x]) zmniejsz_stan();
		if((nowy_stan | stary_stan) == prawo[x]) zwieksz_stan();
		}
	
	stary_stan = PIND & 0b1100;
	}

void zwieksz_stan()
{
	if(licznik<198)licznik++;
	
}

	void zmniejsz_stan()
	{
		if(licznik>0)licznik--;
		
	}

uint8_t S1() //ta funkcja odkca przycisk S1, zwraca 1 gdy wcinito przycisk, 0 gdy nie wcinito. UWAGA!Funkcja zwrci 1 tylko raz na przycinicie
{
	if(time == 0)
	{
		if((PIND & 1<<4) && sS1 > 0)
		{
			sS1 = 0; 
			time = 15;
			return 0;
		}
		if((!(PIND & 1<<4)) && sS1 == 0)
		{
			sS1 = 1;
			time = 15;
			return 1;
		} 
	}
if(time != 0) --time;
return 0;
}

	void sprawdz_poprawnosc() //Sprawdzanie poprawnoci wpisanego kodu
	{
		uint8_t flaga = 1;
		
		for(uint8_t x=0; x<6; x++)
		{
			if (co_wpisano[x] != eeprom_read_byte(x+10)) flaga = 0;
		}
		if(flaga == 1)kod_ok();
		if(flaga == 0)kod_zly();
	}

void kod_ok() // Ta funkcja zostanie wykonana jeli wprowadzony kod by poprawny
{
	PORTD |= 1<<6;
	time_opoznienie = 2000;
	czas_do_przerwy = 5000;
	if(!(PIND & 1<<5))stan = 5;
	else stan = 7;
}

	void kod_zly()
	{
	time_opoznienie = 6000;
	czas_do_przerwy = 5000;
	stan = 6;
	}

// MAIN MAIN MAIN MAIN MAIN MAIN MAIN MAIN
int main()
{
DDRB = 255; //PORTB jako wyjcie(port wywietlaczy)
DDRD = 0b1000011;
TCCR0B |= 1<<CS01 | 1<<CS00; // Preskaler na 64
TIMSK |= 1<<TOIE0; //Overflow Interrupt Enable - odblokowanie przerwania przepenienia licznika

//Konfiguracja przerwania zewntrznego
MCUCR |= 1<<ISC00;		//jakakolwiek zmiania na INT0 wyzwala przerwanie
MCUCR |= 1<<ISC10;		//jakakolwiek zmiania na INT1 wyzwala przerwanie
GIMSK |= 1<<INT0 | 1<<INT1;//Odblokowanie przerwa zewntrznych

PORTD &= ~(1<<6);

wdt_enable(WDTO_1S);

if((!(PIND & 1<<5)) && (!(PIND & 1<<4))){stan = 1; sS1 = 1;} //Jeeli zaoona jest zworka i wcinity przycisk S1 to wchodzimy w tryb programowania

sei();

for(;;)
{
}
return 0;
}

SIGNAL(SIG_OVERFLOW0) // przerwanie co okoo 2ms
{

if(licznik > 198) licznik = 198;

switch(stan)
{
case 0: //stan wpisywania kodu
PORTD &= ~(1<<6);
	if(czas_do_przerwy != 0) --czas_do_przerwy;
	if(czas_do_przerwy == 0) stan = 4;
	
	if(S1())
	{
		switch(ktora_liczba)
		{
		case 0:co_wpisano[0] = (licznik/2); ktora_liczba = 1; stan=2; time2 = 150; liczba = licznik/2; break;
		case 1:co_wpisano[1] = (licznik/2); ktora_liczba = 2; stan=2; time2 = 150; liczba = licznik/2; break;
		case 2:co_wpisano[2] = (licznik/2); ktora_liczba = 3; stan=2; time2 = 150; liczba = licznik/2; break;
		case 3:co_wpisano[3] = (licznik/2); ktora_liczba = 4; stan=2; time2 = 150; liczba = licznik/2; break;
		case 4:co_wpisano[4] = (licznik/2); ktora_liczba = 5; stan=2; time2 = 150; liczba = licznik/2; break;
		case 5:co_wpisano[5] = (licznik/2); ktora_liczba = 0; sprawdz_poprawnosc(); liczba = licznik/2; break;
		default: ktora_liczba = 0; break;
		}
	}
wyswietl(licznik/2,0);
break;

case 1:  //stan programowania nowego kodu
PORTD &= ~(1<<6);
if(S1())
	{		
		switch(ktora_liczba)
		{
		case 0:eeprom_write_byte(10,licznik/2); ktora_liczba = 1; stan=3; time2 = 150; liczba = licznik/2; break;
		case 1:eeprom_write_byte(11,licznik/2); ktora_liczba = 2; stan=3; time2 = 150; liczba = licznik/2;break;
		case 2:eeprom_write_byte(12,licznik/2); ktora_liczba = 3; stan=3; time2 = 150; liczba = licznik/2;break;
		case 3:eeprom_write_byte(13,licznik/2); ktora_liczba = 4; stan=3; time2 = 150; liczba = licznik/2;break;
		case 4:eeprom_write_byte(14,licznik/2); ktora_liczba = 5; stan=3; time2 = 150; liczba = licznik/2;break;
		case 5:eeprom_write_byte(15,licznik/2); ktora_liczba = 0; stan=3; time2 = 150; liczba = licznik/2;stan = 0; break;
		default: ktora_liczba = 0; break;
		}
	}
wyswietl(licznik/2,0b11);
break;

case 2:  //stan po wciniciu przycisku w stanie 1
PORTD &= ~(1<<6);
if(time2 > 0)time2--;
if(time2 == 0) stan = 0;
wyswietl(liczba,0b01);
break;

case 3:  //stan po wciniciu przycisku w stanie 2
PORTD &= ~(1<<6);
if(time2 > 0)time2--;
if(time2 == 0) stan = 1;
wyswietl(liczba,0b10);
break;

case 4: //stan upienia (wygaszenie wywietlaczy)
PORTD &= ~(1<<6);
wyswietl(100,0b00);
ktora_liczba = 0;
licznik = 0;
stan = 8;
break;

case 5:
wyswietl(100,0b01); //stan wczenia wyjcia na okrelony czas
if(time_opoznienie > 0)time_opoznienie--;
if(time_opoznienie == 0)
	{
	PORTD &= ~(1<<6);
	stan = 4;
	}
break;

case 6:  //stan po wpisaniu zego kodu
PORTD &= ~(1<<6); //na wszelki wypadek wyjcie ustawiamy w stan 0
wyswietl(100,0b10);
if(time_opoznienie > 0)time_opoznienie--;
if(time_opoznienie == 0)
	{
	stan = 4;
	}
break;

case 7:  //stan wczenia wyjcia na czas do wcinicia S1
wyswietl(100,0b01);
if(S1())
	{
	PORTD &= ~(1<<6);
	stan = 4;
	}
break;

case 8: //stan upienia - miganie praw diod
czas_zgaszenia++;
if(czas_zgaszenia < 900) wyswietl(100,0b00);
if(czas_zgaszenia >= 900) wyswietl(100,0b01);
if(czas_zgaszenia > 950)czas_zgaszenia = 0;

break;

default:
stan = 0;
break;
}

wdt_reset();// restet watchdoga
}

SIGNAL(SIG_INTERRUPT0)
{
if(stan==8) stan = 0;
czas_do_przerwy = 5000;
ktora_strona();
}

SIGNAL(SIG_INTERRUPT1)
{
if(stan == 8) stan = 0;
czas_do_przerwy = 5000;
ktora_strona();
}




